/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %     Copyright (C) 1994, by WATCOM International Inc.  All rights    %
   %     reserved.  No part of this software may be reproduced or        %
   %     used in any form or by any means - graphic, electronic or       %
   %     mechanical, including photocopying, recording, taping or        %
   %     information storage and retrieval systems - except with the     %
   %     written permission of WATCOM International Inc.                 %
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#ifndef _WOLEGUID_HPP_INCLUDED
#define _WOLEGUID_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,8);
#pragma enum int;
#endif

#ifndef _stdole_HPP_INCLUDED
#   include "wstdole.hpp"
#endif
#ifndef _WOLETYPE_HPP_INCLUDED
#   include "woletype.hpp"
#endif

class WCMCLASS WOleWGUIDManager {

    public:

        /**************************************************************
         * Static Methods
         **************************************************************/

        // GUID conversions
        static void WGUIDToGUID( const WGUID & wguidSrc, GUID & guid );
        static void GUIDToWGUID( const GUID & guidSrc, WGUID & wguid );

        // WString conversions
        static WBool WGUIDToWString( const WGUID & wguidSrc, WString & str );
        static WBool GUIDToWString( const GUID & guidSrc, WString & str );

        static WBool WStringToWGUID( const WString & strSrc, WGUID & wguid );
        static WBool WStringToGUID( const WString & strSrc, GUID & guid );

        // ProgID conversions
        static WBool WGUIDToProgID( const WGUID & wguidSrc, WString & progID );
        static WBool GUIDToProgID( const GUID & guidSrc, WString & progID );

        static WBool ProgIDToWGUID( const WString & progIDSrc, WGUID & wguid );
        static WBool ProgIDToGUID( const WString & progIDSrc, GUID & guid );

        static WBool GenerateGUID( GUID & guid );
        static WBool GenerateWGUID( WGUID & wguid );

        static WBool IsNull( GUID & guid );
        static WBool IsNull( WGUID & wguid );

};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif

#endif // _WOLEGUID_HPP_INCLUDED

